import java.io.*;

class FileDemo {
	public static void main(String[] args) {
		byte[] arr = {1, 2, 3};

		// Verzeichnis ggf. erstellen
		String dname = "U:/Eigene Dateien/Java/FileDemo/AusDir";
		File dir = new File(dname);
		if (dir.exists()) {
			if (!dir.isDirectory()) {
				System.out.println(dname+" existiert, ist aber kein Verzeichnis.");
				System.exit(1);
			}
		}
		else
			if (dir.mkdirs())
				System.out.println("Verzeichnis "+dname+" erstellt");
			else {
				System.out.println("Verzeichnis "+dname+" konnte nicht erstellt werden.");
				System.exit(1);
			}

		// Datei explizit erstellen
		String name = dname+"/Ausgabe.txt";
		File f = new File(name);
		if (!f.exists()) {
			try {
				f.createNewFile();
				System.out.println("Datei "+name+" erstellt");
			} catch (Exception e) {
				System.out.println("Fehler beim Erstellen der Datei "+name);
				System.exit(1);
			}
		}

		// Ausgabedatei ffnen und schreiben
		FileOutputStream fos = null;
		try {
			fos = new FileOutputStream(f);
			fos.write(arr);
			System.out.println("Daten geschrieben in Datei "+name);
			fos.close();
		} catch (Exception e) {
			System.out.println("\nFehler beim Schreiben in Datei "+name);
			System.exit(1);
		}

		// ber Ausgabedatei informieren
		System.out.println("\nEigenschaften der Datei "+name);
		System.out.println("  Vollst. Pfad:       " + f.getAbsolutePath());
		System.out.println("  Groesse in Bytes:   " + f.length());
		System.out.println("  Schreiben moeglich: " + f.canWrite()+"\n");

		// Verzeichnisinhalt auflisten
		File names[] = new File(".").listFiles();
		System.out.println("Dateien im akt. Verzeichnis:");
		for (File fi : names)
			System.out.println(" "+fi.getName());
		names = new File(".").listFiles(new FileFilter("java"));
		System.out.println("\nDateien im akt. Verzeichnis mit Extension .java:");
		for (File fi : names)
			System.out.println(" "+fi.getName());

		// Ausgabedatei umbenennen
		File fn = new File(dname+"/Rausgabe.txt");
		if (f.renameTo(fn))
			System.out.println("\nDatei "+f.getName()+" umbenannt in "+fn.getName());
		else {
			System.out.println("Fehler beim Umbenennen der Datei "+f.getName());
			fn = f;
		}

		// Ausgabedatei lschen
		if (fn.delete())
			System.out.println("Datei "+fn.getName()+" geloescht");
		else {
			System.out.println("Fehler beim Loeschen der Datei "+fn.getName());
			System.exit(1);
		}

		// Verzeichnis lschen
		if (dir.delete())
			System.out.println("Verzeichnis "+dir.getName()+" geloescht");
		else {
			System.out.println("Fehler beim Loeschen des Ordners "+dir.getName());
			System.exit(1);
		}
	}
}