// Mit statischen Elementen

public class Bruch {
	private int zaehler;          // wird automatisch mit 0 initialisiert
	private int nenner = 1;       // wird manuell mit 1 initialisiert
	private String etikett = "";  // die Ref.typ-Init. auf null wird ersetzt, siehe Text

	static private int anzahl;
	
	private static int zaehlerVoreinst;
	private static int nennerVoreinst;

	static {
		java.util.Random zuf = new java.util.Random();
		zaehlerVoreinst = zuf.nextInt(5)+1;
		nennerVoreinst = zuf.nextInt(5)+zaehlerVoreinst;
		System.out.println("Klasse Bruch geladen");
	}

	public Bruch(int zpar, int npar, String epar) {
		zaehler = zpar;
		nenner  = npar;
		etikett = epar;
		anzahl++;
	}
	
	public Bruch() {
		zaehler = zaehlerVoreinst;
		nenner = nennerVoreinst;
		anzahl++;
	}

	public void setzeZaehler(int zpar) {zaehler = zpar;}

	public boolean setzeNenner(int n) {
		if (n != 0)	{
			nenner = n;
			return true;
		} else
			return false;
	}

	public void setzeEtikett(String epar) {
		int rind = epar.length();
		if (rind > 40)
			rind = 40;
		etikett = epar.substring(0, rind);
	}
	
	public int gibZaehler() {return zaehler;}

	public int gibNenner()	{return nenner;}

	public String gibEtikett()	{return etikett;}

	public void kuerze() {
		if (zaehler != 0) {
			int rest;
			int ggt = Math.abs(zaehler);
			int divisor = Math.abs(nenner);
			do {
				rest = ggt % divisor;
				ggt = divisor;
				divisor = rest;
			} while (rest > 0);			
			zaehler /= ggt;
			nenner  /= ggt;
		}
	}	

	public void addiere(Bruch b) {
		zaehler = zaehler*b.nenner + b.zaehler*nenner;
		nenner = nenner*b.nenner;
		kuerze();
	}

	public void addiere(int zpar, int npar, boolean autokurz) {
		zaehler = zaehler*npar + zpar*nenner;
		nenner = nenner*npar;
		if (autokurz)
			kuerze();
	}

	public void addiere(Bruch ... bar) {
		for (Bruch b : bar)
			addiere(b);
	}
	
	public boolean frage() {
		int n;
		System.out.print("Zaehler: ");
		zaehler = Simput.gint();
		System.out.print("Nenner : ");
		n = Simput.gint();
		if (n != 0) {
			nenner = n;
			return true;
		}
		else {
			System.out.println("Der Nenner darf nicht 0 werden.");
			return false;
		}
	}

	public void zeige() {
		String luecke = "";
		for (int i=1;i<=etikett.length();i++)
			luecke = luecke + " ";
		System.out.println(" " + luecke  + "   " + zaehler + "\n" +
		                   " " + etikett + " -----\n" +
		                   " " + luecke  + "   " + nenner + "\n");
	}

	public void duplW(Bruch bc) {
		bc.zaehler = zaehler;
		bc.nenner = nenner;
	}
	
	public Bruch klone() {
		return new Bruch(zaehler, nenner, etikett);
	}

	static public int hanz() {return anzahl;}	
}