// Mit Aggregation

public class Bruch {
	private int zaehler;          // wird automatisch mit 0 initialisiert
	private int nenner = 1;       // wird manuell mit 1 initialisiert
	private String etikett = "";  // die Ref.typ-Init. auf null wird ersetzt, siehe Text

	static private int anzahl;

	public Bruch(int zpar, int npar, String epar) {
		zaehler = zpar;
		nenner  = npar;
		etikett = epar;
		anzahl++;
	}
	
	public Bruch() {anzahl++;}

	public void setzeZaehler(int zpar) {zaehler = zpar;}

	public boolean setzeNenner(int n) {
		if (n != 0)	{
			nenner = n;
			return true;
		} else
			return false;
	}

	public void setzeEtikett(String epar) {
		int rind = epar.length();
		if (rind > 40)
			rind = 40;
		etikett = epar.substring(0, rind);
	}
	
	public int gibZaehler() {return zaehler;}

	public int gibNenner()	{return nenner;}

	public String gibEtikett()	{return etikett;}

	int ggTr(int a, int b) {
		int rest = a % b;
		if (rest == 0)
			return b;
		else
			return ggTr(b, rest);
	}

	int ggTi(int a, int b) {
		int rest;
		do {
			rest = a % b;
			a = b;
			b = rest;
		} while (rest > 0);
		return a;
	}

	public void kuerze() {
		if (zaehler != 0) {
			int teiler = ggTi(Math.abs(zaehler), Math.abs(nenner));
			zaehler /= teiler;
			nenner  /= teiler;
		}
	}

	public void addiere(Bruch b) {
		zaehler = zaehler*b.nenner + b.zaehler*nenner;
		nenner = nenner*b.nenner;
		kuerze();
	}

	public void addiere(int zpar, int npar, boolean autokurz) {
		zaehler = zaehler*npar + zpar*nenner;
		nenner = nenner*npar;
		if (autokurz)
			kuerze();
	}

	public void addiere(Bruch ... bar) {
		for (Bruch b : bar)
			addiere(b);
	}

	public void multipliziere(Bruch b) {
		zaehler = zaehler*b.zaehler;
		nenner = nenner*b.nenner;
		kuerze();
	}
	
	public boolean frage() {
		int n;
		System.out.print("Zaehler: ");
		zaehler = Simput.gint();
		System.out.print("Nenner : ");
		n = Simput.gint();
		if (n != 0) {
			nenner = n;
			return true;
		}
		else {
			System.out.println("Der Nenner darf nicht 0 werden.");
			return false;
		}
	}

	public void zeige() {
		String luecke = "";
		for (int i=1;i<=etikett.length();i++)
			luecke = luecke + " ";
		System.out.println(" " + luecke  + "   " + zaehler + "\n" +
		                   " " + etikett + " -----\n" +
		                   " " + luecke  + "   " + nenner + "\n");
	}

	public void duplW(Bruch bc) {
		bc.zaehler = zaehler;
		bc.nenner = nenner;
	}
	
	public Bruch klone() {
		return new Bruch(zaehler, nenner, etikett);
	}

	static public int hanz() {return anzahl;}	

}