import java.net.*;
import java.io.*;
import java.text.*;
import java.util.*;

class URLConnectionDemo {
	public static void main(String[] args) {
		try {
			String urlString;
			if (args.length == 0)
				urlString = "http://www.uni-trier.de/";
			else
				urlString = args[0];

			// URLConnection-Objekt generieren
			URL url = new URL(urlString);
			URLConnection urlConn = url.openConnection();

			// Request - Header setzen
//			urlConn.setRequestProperty("If-Modified-Since", "Sat, 12 Apr 2004 00:00:00 GMT");
			DateFormat df = DateFormat.getDateTimeInstance();
			urlConn.setIfModifiedSince(df.parse("12.02.2004 00:00:00").getTime());
			
			// Verbindung herstellen und Response-Header entgegennehmen
			urlConn.connect();

			// Response-Header auswerten
			System.out.println("\nResponse-Header:");
			System.out.println("  Content-Type:\t\t"+urlConn.getContentType());
			System.out.println("  Content-Length:\t"+urlConn.getContentLength());
			System.out.println("  Expiration:\t\t"+urlConn.getExpiration());
			System.out.println("  Last Modified:\t"+df.format(new Date(urlConn.getLastModified()))+"\n"); 

			// Inhalt ausgeben
			if (urlConn.getContentLength() > 0) {
				System.out.println("Weiter zum Inhalt mit Enter");
				System.in.read();
				BufferedReader br = new BufferedReader(new InputStreamReader(urlConn.getInputStream()));
				String zeile;
				while ((zeile = br.readLine()) != null)
					System.out.println(zeile);
			}
		} catch (MalformedURLException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		} catch (ParseException e) {
			e.printStackTrace();
		}
	}
}
