import java.io.*;
import java.net.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class ChatClient extends JFrame {
	private String host;
	private int port;
	private JTextField eingabe;
	private JTextArea protokoll;
	private BufferedReader br;
	private PrintWriter pw;
	private String zeile;
	private boolean connected = false;
   
	public ChatClient(String host_, int port_) {
		try {
			setTitle("ChatClient (Name: "+InetAddress.getLocalHost().getHostName()+", verbunden mit: "+host_+")");
		} catch (Exception e) {
			setTitle("ChatClient (verbunden mit: "+host_+")");
		}
		host = host_;
		port = port_;
		JPanel panel = new JPanel(new BorderLayout());
		JLabel label = new JLabel("Eingabe: ");
		eingabe = new JTextField();
		eingabe.addActionListener(
			new ActionListener() {
				public void actionPerformed(ActionEvent event ) {
				   senden(event.getActionCommand());
				   eingabe.setText("");
				}
			}
		);
		panel.add(label, BorderLayout.WEST);
		panel.add(eingabe, BorderLayout.CENTER);
		getContentPane().add(panel, BorderLayout.SOUTH);

      protokoll = new JTextArea();
      protokoll.setEditable(false);
      protokoll.setFocusable(false);
      getContentPane().add(new JScrollPane(protokoll), BorderLayout.CENTER);

      setSize(500, 200);
      setVisible(true);
      setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
      addWindowListener(new Ex());
   }

	public void starten() {
		verbinden();
		empfangen();
	}
   
   public void verbinden() {
		try {
			Socket server = new Socket(host, port);
			br = new BufferedReader(new InputStreamReader(server.getInputStream()));
			pw = new PrintWriter(server.getOutputStream(), true);
			connected = true;
		} catch (Exception e) {
			JOptionPane.showMessageDialog(null, "Fehler bei der Verbindungsaufnahme", "ChatClient", JOptionPane.ERROR_MESSAGE);
			System.exit(1);
		}
   }
   
   public void senden(String s) {
		if (connected)
			pw.println(s);
   }
   
   public void empfangen() {
		try {
			while ((zeile = br.readLine()) != null) {
				protokoll.append(zeile+"\n"); // JTextarea.append() ist thread-sicher!
				protokoll.setCaretPosition(protokoll.getText().length()-1); // Vert. Rollen erzwingen
				if ( zeile.equals("Tsch") ) {
					try {Thread.sleep(1000);
					} catch (Exception e) {}
					System.exit(0);
				}
			}
		} catch (IOException e) {
			JOptionPane.showMessageDialog(null, "Kontakt mit dem Server verloren", "ChatClient", JOptionPane.ERROR_MESSAGE);
			System.exit(1);
		}
   }

   private class Ex extends WindowAdapter {
	   public void windowClosing(WindowEvent e) {
		   senden("quit");
	   }
	}
}

