import java.net.*;
import java.util.*;
import java.text.*;

public class ChatServer {
	private int port;
	private int nconn, nummer;
	private DateFormat df = DateFormat.getDateTimeInstance();
	private ArrayList lot = new ArrayList(); 
	private ClientThread ct = null;

	public ChatServer(int port_) {
		port = port_;
	}
	
	public void run() {
		try {
			ServerSocket server = new ServerSocket(port);
			System.out.println("ChatServer gestartet ("+df.format(new Date())+")");
			while(true) {
				Socket client = server.accept();
				nummer++;
				nconn++;
				prot("Verbindung Nummer "+nummer+" gestartet"+
					"\n  Rechner: "+client.getInetAddress().getHostName()+
					" IP: "+ client.getInetAddress().getHostAddress()+
					" Port: "+client.getPort()+
					"\n  Anzahl der aktiven Verbindungen: "+nconn);
				ct = new ClientThread(this, client, nummer);
				ct.start();
				lot.add(ct);
			}
		} catch (Exception e) {
			prot("Fehler: \n  "+e.toString());
		}
	}

	public  synchronized void tellAll(String s) {
		for (Object ct : lot)
			((ClientThread)ct).tellClient(s);
	}
	
	public  synchronized void decr(int nummer, String name) {
		nconn--;
		System.out.println("\n"+df.format(new Date())+ " Verbindung Nummer "+nummer+" beendet"+
				"\n  Rechner: "+name+"\n  Anzahl der aktiven Verbindungen: "+nconn);
	}

	public  synchronized void prot(String s) {
		System.out.println("\n"+df.format(new Date())+" "+s);
	}	

	public  synchronized int getNConnects() {
		return nconn;
	}	
}