import java.io.*;
import java.net.*;

public class ClientThread extends Thread {
	private Socket client;
	private ChatServer cs;
	private String name;
	private int nummer;
	private PrintWriter pw;
	
	public ClientThread(ChatServer cs_, Socket cl, int nr) {
		cs = cs_;
		client = cl;
		name = cl.getInetAddress().getHostName();
		int pos = name.indexOf(".");
		if (pos > 0)
			name = name.substring(0, pos);
		nummer = nr;
	}

	public void run() {
		String zeile;
		try {
			BufferedReader br = new BufferedReader(new InputStreamReader(client.getInputStream()));
			pw = new PrintWriter(client.getOutputStream(), true);
			pw.println("Willkommen, "+name+"! - Aktive Teilnehmer: "+cs.getNConnects()+" - Beenden mit 'quit'");
			while ((zeile = br.readLine()) != null) {
				if (zeile.trim().equals("quit")) {
					pw.println("Tsch");
					break;
				}
				cs.tellAll(name+": "+zeile);
			}
			client.close();
		} catch (Exception e) {
			cs.prot("Fehler bei Verbindung Nummer "+nummer+" mit "+name+"\n"+e.toString());
		} finally {
			cs.decr(nummer, name);			
		}
	}
	
	public void tellClient(String s) {
		pw.println(s);
	}
}