import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

class SwApp extends JFrame {
	String labelPrefix = "Anzahl der Klicks: ";
	final static String titel = "Swing-Demo";
	JLabel label;
	JPanel panli;
	JButton button;
	int numClicks = 0;
	final byte maxicon = 3;
	ImageIcon icons[];
	JLabel labicon;
	byte iconr = 0;

	SwApp() {
		// ber den Basisklassen-Konstruktor erhlt das Hauptfenster einen Titel.
		super(titel);
		
		// cont ist eine bequeme Referenz auf die Inhaltsschicht des JFrame-Fensters
		Container cont = getContentPane();
		
		// JButton-Komponente initilisieren
		button = new JButton("Ich mag Swing!");
		// Der Schalter kann auch mit <Alt><S> ausgelst werden.
		button.setMnemonic(KeyEvent.VK_S);
		button.setToolTipText("Befehlsschalter");
		
		// JLabel-Komponente mit Text initialisieren
		label = new JLabel(labelPrefix + "0    ");
		label.setToolTipText("Label mit Text");
		
		// JPanel-Komponente erzeugen.
		// Dieser "immediate container" dient zur Positionierung von Komponenten.
		panli = new JPanel();
		
		// Der Container wird "frei gestellt".
		panli.setBorder(BorderFactory.createEmptyBorder(30, 30, 30, 30));
		
		// Layout-Manager fr die JPanel-Komponente erzeugen
		// Hier wird dafr gesorgt, dass alle Komponentn in einer Spalte stehen.
		panli.setLayout(new GridLayout(0, 1));
		
		// Der JButton und das Text-JLabel werden auf die JPanel-Komponente gesetzt.
		panli.add(button);
		panli.add(label);
		
		// Das JPanel wird auf den JFrame gesetzt.
		cont.add(panli, BorderLayout.CENTER);
		
		// Icons erzeugen
		icons = new ImageIcon[maxicon];
		icons[0] = new ImageIcon("duke.gif");
		icons[1] = new ImageIcon("fight.gif");
		icons[2] = new ImageIcon("snooze.gif");
		
		// JLabel mit Icon initialisieren
		labicon = new JLabel(icons[0]);
		labicon.setToolTipText("Label mit Icon");		
		
		// Das Icon-Label wird auf den JFrame gesetzt.
		cont.add(labicon, BorderLayout.EAST);
		
		// Fr den JButton wird ein ActionListener registriert.
		// Dazu wird eine anonyme Klasse an Ort und Stelle definiert.
		button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				numClicks++;
				label.setText(labelPrefix + numClicks);
				if (iconr < maxicon-1)
					iconr++;
				else
					iconr = 0;
				labicon.setIcon(icons[iconr]);
			}
		});
		
		// Der JFrame erhlt einen Handler fr Fenster-Ereignisse.
		addWindowListener(new Ex());
		
		// Diese Methode verhindert ein Schlieen unter Miachtung des WindowListeners
		setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
		
		// JFrame-Gre festlegen
		setSize(300, 150);
		
		// JFrame anzeigen
		this.setVisible(true);
    }

	public static void main(String[] args) {
		// Instanz unserer Klasse erzeugen
		new SwApp();
	}

	// Der WindowListener fr den JFrame (= top level container) wird als interne Klasse definiert.
	class Ex extends WindowAdapter {
		public void windowClosing(WindowEvent e) {
			if (JOptionPane.showConfirmDialog(e.getWindow(), 
				  "Wollen Sie nach "+ numClicks +
				  " Klicks wirklich schon aufhren?", 
				  titel, JOptionPane.YES_NO_OPTION) == 0)
				System.exit(0);
		}
	}
}
