import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

class MouseEventDemo extends JFrame implements MouseListener, MouseMotionListener {
	JLabel status = new JLabel();
	
	MouseEventDemo() {
		super("MouseEventDemo");
		status.setHorizontalAlignment(SwingConstants.CENTER);
		getContentPane().add(status, BorderLayout.CENTER);
		
		addMouseListener(this);	
		addMouseMotionListener(this);
		
		setDefaultCloseOperation(EXIT_ON_CLOSE);

		setSize(300, 100);
		setVisible(true);
	}

	public void mouseClicked(MouseEvent e) {
		status.setText("Mausklick bei ("+e.getX()+", "+e.getY()+")");
	}
	public void mousePressed(MouseEvent e) {
		status.setText("Maustaste gedrckt bei ("+e.getX()+", "+e.getY()+")");
	}
	public void mouseReleased(MouseEvent e) {
		status.setText("Maustaste losgelassen bei ("+e.getX()+", "+e.getY()+")");
	}
	public void mouseEntered(MouseEvent e) {
		status.setText("Maus eingedrungen bei ("+e.getX()+", "+e.getY()+")");
	}
	public void mouseExited(MouseEvent e) {
		status.setText("Maus entwichen bei ("+e.getX()+", "+e.getY()+")");
	}
	public void mouseDragged(MouseEvent e) {
		status.setText("Maus gezogen bei ("+e.getX()+", "+e.getY()+")");
	}
	public void mouseMoved(MouseEvent e) {
		status.setText("Maus bewegt bei ("+e.getX()+", "+e.getY()+")");
	}

	public static void main(String[] arg) {
		new MouseEventDemo();
	}
}