import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

class Umschalter extends JFrame {
	JCheckBox bold, italic;
	JRadioButton arial, tiro, courier;
	JLabel bsp;
	JPanel cbPanel, rbPanel;
	ButtonGroup rbGroup;

	Font	courierFont = new Font("Courier", Font.PLAIN, 16),
			tiroFont = new Font("TimesRoman", Font.PLAIN, 16),
			arialFont = new Font("Arial", Font.PLAIN, 16);
		
	Umschalter() {
		super("JCheckBox und JRadioButton");
		Container cont = getContentPane();
		cont.setLayout(new GridLayout(1, 3));

		cbPanel = new JPanel();
		cbPanel.setLayout(new GridLayout(0, 1));
		cont.add(cbPanel);

		rbPanel = new JPanel();
		rbPanel.setLayout(new GridLayout(0, 1));
		cont.add(rbPanel);
		
		bsp = new JLabel("Beispiel-Text    ");
		cont.add(bsp);
		bsp.setFont(tiroFont);
		
		bold = new JCheckBox("Fett");
		italic = new JCheckBox("Kursiv");
		cbPanel.add(bold);
		cbPanel.add(italic);

		CheckHandler cbHandler = new CheckHandler();
		bold.addItemListener(cbHandler);
		italic.addItemListener(cbHandler);

		courier = new JRadioButton("Courier", false);
		tiro = new JRadioButton("Times Roman", true);
		arial = new JRadioButton("Arial", false);
		rbPanel.add(courier);
		rbPanel.add(tiro);
		rbPanel.add(arial);
		
		rbGroup = new ButtonGroup();
		rbGroup.add(courier);
		rbGroup.add(tiro);
		rbGroup.add(arial);
		
		RadioHandler rbHandler = new RadioHandler();
		courier.addItemListener(rbHandler);
		tiro.addItemListener(rbHandler);
		arial.addItemListener(rbHandler);

		setDefaultCloseOperation(EXIT_ON_CLOSE);
       
		setSize(550, 140);
		setVisible(true);
	}
	
	public static void main(String[] args) {
		new Umschalter();
	}

	class RadioHandler implements ItemListener {
		public void itemStateChanged(ItemEvent e) {
			int style = bsp.getFont().getStyle();
			Font oldFont = null;
			if (e.getSource() == courier) {
				oldFont = courierFont;
			} else if (e.getSource() == tiro) {
				oldFont = tiroFont;
			} else if (e.getSource() == arial) {
				oldFont = arialFont;
			}
			bsp.setFont(oldFont.deriveFont(style));
		}
	}

	class CheckHandler implements ItemListener {
		public void itemStateChanged(ItemEvent e) {
			Font oldFont = bsp.getFont(), newFont = null;
			int oldStyle = oldFont.getStyle(), newStyle = 0;
			
			if (e.getSource() == bold) {
				if (e.getStateChange() == ItemEvent.SELECTED) {
					newStyle = oldStyle + Font.BOLD;
				} else {
					newStyle = oldStyle - Font.BOLD;
				}
			} else if (e.getSource() == italic) {
				if (e.getStateChange() == ItemEvent.SELECTED) {
					newStyle = oldStyle + Font.ITALIC;
				} else {
					newStyle = oldStyle - Font.ITALIC;
				}
			}

			newFont = oldFont.deriveFont(newStyle);
			bsp.setFont(newFont);
		}
	}
}